"use strict";

var _getFieldRules = _interopRequireDefault(require("../utils/get-field-rules"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('getFieldRules', function () {
  it('#1 Get rules of field', function () {
    expect((0, _getFieldRules.default)('employees.1.name', {
      'employees.*.name': 'required',
      'employees.1.name': 'required',
      'employees.*.email': 'required|email',
      'employees.*.age': ''
    })).toEqual({
      'employees.1.name': ['required']
    });
  });
  it('#2 Get rules of field', function () {
    expect((0, _getFieldRules.default)('employees.1.name', {
      'employees.*.name': ['required', {
        not_in: [1, 2]
      }],
      'employees.1.name': 'required'
    })).toEqual({
      'employees.1.name': ['required', {
        not_in: [1, 2]
      }]
    });
  });
  it('#3 Get rules of field', function () {
    expect((0, _getFieldRules.default)('employees.1.name', {
      'employees.*.name': ['required', {
        not_in: [1, 2]
      }],
      'employees.1.name': 'required|email'
    })).toEqual({
      'employees.1.name': ['required', 'email', {
        not_in: [1, 2]
      }]
    });
  });
  it('#4 Get rules of field', function () {
    expect((0, _getFieldRules.default)('employees.1.name', {
      'employees.*.name': ['required', {
        not_in: [1, 2]
      }],
      'employees.1.name': 'required|email|same:password'
    })).toEqual({
      'employees.1.name': ['required', 'email', 'same:password', {
        not_in: [1, 2]
      }]
    });
  });
});