"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

var _ = _interopRequireDefault(require("../"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact.default()
});

var getComonent = function getComonent() {
  return (0, _.default)(function (_ref) {
    var onChange = _ref.onChange;
    return _react.default.createElement("div", null, _react.default.createElement("input", {
      name: "email",
      onChange: onChange
    }));
  }, {
    rules: {
      name: "required",
      email: "required",
      "items.*.name": "required"
    },
    messages: {
      "required.email": "email is required.",
      "required.items.0.required": "Item 0 is required"
    }
  });
};

it('renders without crashing', function () {
  var div = document.createElement('div');
  var Component = (0, _.default)(function (_ref2) {
    var onChange = _ref2.onChange;
    return _react.default.createElement("div", null, _react.default.createElement("input", {
      name: "email",
      onChange: onChange
    }));
  });

  _reactDom.default.render(_react.default.createElement(Component, null), div);

  _reactDom.default.unmountComponentAtNode(div);
});
it('renders without crashing', function () {
  var Component = (0, _.default)(function (_ref3) {
    var onChange = _ref3.onChange;
    return _react.default.createElement("div", null, _react.default.createElement("input", {
      name: "email",
      onChange: onChange
    }));
  });
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  expect(rendered.html()).toEqual("<div><input name=\"email\"/></div>");
});
it('Changing text input', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      type: "text",
      name: "name",
      value: "solaiman"
    }
  });
  expect(rendered.props().value("name")).toEqual("solaiman");
});
it('Changing text input', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      type: "checkbox",
      name: "name",
      value: "solaiman",
      checked: true
    }
  });
  expect(rendered.props().value("name")).toBe(true);
});
it('Changing text input', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      type: "select-multiple",
      name: "name",
      selectedOptions: [{
        value: 1
      }, {
        value: 2
      }]
    }
  });
  expect(rendered.props().value("name")).toEqual([1, 2]);
});
describe('#1 Validation with default messages', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  var name = "name";
  rendered.props().onChange({
    target: {
      name: name,
      type: "text",
      value: ""
    }
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  it('Print Messages JSX element', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name")).html()).toEqual('<span class="">The name field is required.</span>');
  });
  it('Print Messages JSX element with className', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name", "is-invalid")).html()).toEqual('<span class="is-invalid">The name field is required.</span>');
  });
  it('Print plain text error', function () {
    expect(rendered.props().error("name", true)).toEqual('The name field is required.');
  });
});
describe('#2 Validation onBlur with default messages', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  var name = "name";
  rendered.props().onBlur({
    target: {
      name: name,
      type: "text",
      value: ""
    }
  }).then(function () {}).catch(function () {});
  it('Print Messages JSX element', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name")).html()).toEqual('<span class="">The name field is required.</span>');
  });
  it('Print Messages JSX element with class Name', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name", "is-invalid")).html()).toEqual('<span class="is-invalid">The name field is required.</span>');
  });
  it('Print plain text message', function () {
    expect(rendered.props().error("name", true)).toEqual('The name field is required.');
  });
  it('Return null if no errors', function () {
    expect(rendered.props().error("email", true)).toEqual(null);
  });
});
describe('#3 Validation with custom messages', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  var name = "email";
  rendered.props().onChange({
    target: {
      name: name,
      type: "text",
      value: ""
    }
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  it('Print Messages JSX element', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name")).html()).toEqual('<span class="">The name field is required.</span>');
  });
  it('Print Messages JSX element with className', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("name", "is-invalid")).html()).toEqual('<span class="is-invalid">The name field is required.</span>');
  });
  it('Print plain text message', function () {
    expect(rendered.props().error("name", true)).toEqual('The name field is required.');
  });
  it('Print Messages JSX element', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("email")).html()).toEqual('<span class="">email is required.</span>');
  });
  it('Print Messages JSX element with className', function () {
    expect((0, _enzyme.shallow)(rendered.props().error("email", "is-invalid")).html()).toEqual('<span class="is-invalid">email is required.</span>');
  });
  it('Print plain text message', function () {
    expect(rendered.props().error("email", true)).toEqual('email is required.');
  });
});
it('Validation Passed', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      name: "name",
      type: "text",
      value: "solaiman"
    }
  });
  rendered.props().onChange({
    target: {
      name: "email",
      type: "text",
      value: "psokmail@gmail.com"
    }
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  expect(Object.keys(rendered.props().errors()).length).toEqual(0);
});
it('Validation onBlur Passes', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  var name = "name";
  rendered.props().onChange({
    target: {
      name: name,
      type: "text",
      value: "Solaiman"
    }
  });
  rendered.props().onBlur({
    target: {
      name: name,
      type: "text"
    }
  });
  expect(rendered.props().error(name, true)).toEqual(null);
});
it('Add an item to array', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  expect(rendered.props().value('items', []).length).toEqual(0);
  rendered.props().addValue('items', {
    id: 1
  });
  expect(rendered.props().value('items.0')).toEqual({
    id: 1
  });
  rendered.props().addValue('items', {
    id: 1
  });
  expect(rendered.props().value('items', []).length).toEqual(2);
});
describe('Remove item from array', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  it('value return default value', function () {
    expect(rendered.props().value('items', []).length).toEqual(0);
  });
  it('Array updated', function () {
    rendered.props().addValue('items', 1);
    rendered.props().addValue('items', 2);
    rendered.props().addValue('items', 3);
    rendered.props().addValue('items', 4);
    rendered.props().addValue('items', 5);
    expect(rendered.props().value('items', []).length).toEqual(5);
  });
  it('Array updated', function () {
    rendered.props().removeValue('items.3');
    expect(rendered.props().value('items', []).length).toEqual(4);
  });
  it('Array updated', function () {
    rendered.props().removeValue('items.0');
    rendered.props().removeValue('items.1');
    expect(rendered.props().value('items', []).length).toEqual(2);
  });
});
it('Rearrange messages after Remove item from array', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().addValue('items', {
    name: "solaiman"
  });
  rendered.props().addValue('items', {
    name: ""
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  rendered.props().removeValue('items.0');
  expect(rendered.props().error("items.0.name", true)).toEqual('The items.1.name field is required.');
});
it('Rearrange messages after Remove item from array', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().addValue('items', {
    name: ""
  });
  rendered.props().addValue('items', {
    name: "Solaiman"
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  rendered.props().removeValue('items.0');
  expect(rendered.props().error("items.0.name", true)).toEqual(null);
});
it('Get values', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().addValue('items', {
    name: "solaiman"
  });
  rendered.props().addValue('items', {
    name: ""
  });
  expect(rendered.props().values()).toEqual({
    items: [{
      name: "solaiman"
    }, {
      name: ""
    }]
  });
});
describe('hasErrors', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      name: "name",
      type: "text",
      value: ""
    }
  });
  rendered.props().onChange({
    target: {
      name: "email",
      type: "text",
      value: "psokmail@gmail.com"
    }
  });
  rendered.props().addValue('items', {
    name: "solaiman"
  });
  rendered.props().addValue('items', {
    name: ""
  });
  rendered.props().validate().then(function () {}).catch(function () {});
  it('Direct field is invalid', function () {
    expect(rendered.props().hasError('name')).toBe(true);
  });
  it('direct field is valid', function () {
    expect(rendered.props().hasError('email')).toBe(false);
  });
  it('Deep Field is invalid', function () {
    expect(rendered.props().hasError('items.1.name')).toBe(true);
  });
  it('Deep Field is valid', function () {
    expect(rendered.props().hasError('items.0.name')).toBe(false);
  });
  it('Return a string on invalid  ', function () {
    expect(rendered.props().hasError('items.1.name', 'is-invalid')).toBe('is-invalid');
  });
  it('Return a string on valid  ', function () {
    expect(rendered.props().hasError('items.0.name', 'is-invalid', 'is-valid')).toBe('is-valid');
  });
});
describe('setValues', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      name: "name",
      type: "text",
      value: ""
    }
  });
  var values = {
    name: "Solaiman",
    email: "psokmail@gmail.com",
    items: [{
      id: 1
    }],
    tags: ["javascript", "react"]
  };
  rendered.props().setValues(values);
  it('Return all values', function () {
    expect(rendered.props().values()).toEqual(values);
  });
  it('Return single value', function () {
    expect(rendered.props().value('name')).toEqual(values.name);
  });
  it('Return array', function () {
    expect(rendered.props().value('items')).toEqual(values.items);
  });
  it('Return default value', function () {
    expect(rendered.props().value('age', 28)).toEqual(28);
  });
});
describe('Reset', function () {
  var Component = getComonent();
  var rendered = (0, _enzyme.shallow)(_react.default.createElement(Component, null));
  rendered.props().onChange({
    target: {
      name: "name",
      type: "text",
      value: ""
    }
  });
  rendered.props().reset();
  it('Return all values', function () {
    expect(rendered.props().values()).toEqual({});
    expect(rendered.props().submitted).toBe(false);
    expect(rendered.props().submitted).toBe(false);
  });
});